.\" filter.man
.\" Rob Earhart
.\" $Id$
.\"
.\"         Copyright 1997 by Carnegie Mellon University
.\"
.\"                       All Rights Reserved
.\"
.\" Permission to use, copy, modify, and distribute this software and its
.\" documentation for any purpose and without fee is hereby granted,
.\" provided that the above copyright notice appear in all copies and that
.\" both that copyright notice and this permission notice appear in
.\" supporting documentation, and that the name of CMU not be
.\" used in advertising or publicity pertaining to distribution of the
.\" software without specific, written prior permission.
.\"
.\" CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
.\" ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
.\" CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
.\" ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
.\" WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
.\" ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
.\" SOFTWARE.
.\"
.na
.TH FILTER 1 CMU
.SH NAME
filter - filters mail messages
.SH SYNOPSIS
\fBfilter \fR[ \fB-p \fR] \fIfilterfile
.SH DESCRIPTION
.P
\fIfilter\fR is a quick-and-dirty implementation of
draft\-showalter\-sieve\-00, to gain operational experience with the
proposed internet mail filtering language.  It is \fBnot\fR intended
to be a production application.
.P
\fIfilter\fR reads in the filter file specified on the command line,
reads an email message on its standard input, applies the filter, and
prints out the actions that should be taken.  The actions are as
follows:
.TP
bounce
The message should be returned to its sender.
.TP
fileinto \fIfolder\fR
The message should be inserted into the folder \fIfolder\fR.
.TP
forward \fIaddress\fR
The message should be forwarded to the address \fIaddress\fR.
.TP
normal
The message should be processed as it would be in the absence of a
filter.
.TP
reply \fI"text"\fR
The message contained in \fItext\fR should be sent back to the sender
of the message.
.TP
toss
The message should be discarded.
.SH OPTIONS
.TP
-p
Causes \fIfilter\fR to read in a filter and print out its internal
version of what it thinks it read; very useful for debugging the
program, but not useful for much else.
.SH FILES
.P
ftp://ftp.ietf.org/internet\-drafts/draft\-showalter\-sieve\-00.txt
.SH BUGS
.P
With the -p switch, \fIfilter\fR doesn't backslash-quote strings.
.P
Error recovery is non-existant.
.P
Only 100 headers in a message are supported.
.P
Only 80 characters in header names are supported.
.P
Only 1024 characters in header bodies are supported.
.P
The interface is pretty clunky (there really should be an API for a
handling mechanism that the filter can link against; parsing the
action output is... gross.)
.P
Only quoted strings are supported.
.P
The code is modular, but far from OO.  This would be better written in
SML, or C++ with a decent garbage collector.
.SH AUTHOR
.P
Rob Earhart <earhart+@cmu.edu>
